import { StorageStatisticsSegmentDto } from "../../statistics/storage/dtos/shared/StorageStatisticsSegmentDto";
import { UploadStatisticsDto } from "../../statistics/storage/dtos/shared/UploadStatisticsDto";
import { TypedFileEvent } from "../../statistics/storage/TypedFileEvent";
import { NonEmptyArray } from "../../common/model/NonEmptyArray";
import { BasicFileEvent } from "../../statistics/storage/BasicFileEvent";
import { DailyMonthlyBytesDto } from "../../statistics/storage/dtos/shared/DailyMonthlyBytesDto";
import { StorageStatisticsByTimeDto } from "../../statistics/storage/dtos/shared/StorageStatisticsByTimeDto";
import { InvocationEvent } from "../../statistics/storage/InvocationEvent";
import { DailyMonthlyDurationsDto } from "../../statistics/storage/dtos/shared/DailyMonthlyDurationsDto";
export declare class StatisticsCalculator {
    static calculateStatistics(newEvents: NonEmptyArray<TypedFileEvent>, valueMultiplier: 1 | -1): UploadStatisticsDto;
    static calculateMonthlyDailyBytes(events: BasicFileEvent[]): DailyMonthlyBytesDto;
    static calculateMonthlyDailyDurations(events: InvocationEvent[]): DailyMonthlyDurationsDto;
    static calculateStatisticsSegment(newEvents: NonEmptyArray<BasicFileEvent>, valueMultiplier: 1 | -1): StorageStatisticsSegmentDto;
    static calculateStorageStatisticsByTime(newEvents: NonEmptyArray<BasicFileEvent>, valueMultiplier: 1 | -1): StorageStatisticsByTimeDto;
    private static calculateBytesPerEpochUnit;
    private static calculateDurationsPerEpochUnit;
}
