import { StorageStatisticsByTimeDto, StorageStatisticsSegmentDto } from "@upload-io/upload-shared-iso";
import { StorageStatisticsSegmentUnboxedDto } from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/StorageStatisticsSegmentDto";
import { IsoObjectUtils } from "@upload-io/upload-shared-iso/common/IsoObjectUtils";
import {
  CreatesAndDeletesByTimeDto,
  StorageStatisticsByTimeUnboxedDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/StorageStatisticsByTimeDto";

export interface CacheStatisticsDto {
  all: StorageStatisticsSegmentDto;
  byCacheId: {
    [cacheId: string]: StorageStatisticsSegmentDto | undefined;
  };
  byTime: StorageStatisticsByTimeDto;
}

export interface CacheStatisticsUnboxedDto {
  all: StorageStatisticsSegmentUnboxedDto;
  byCacheId: {
    [cacheId: string]: StorageStatisticsSegmentUnboxedDto | null;
  };
  byTime: StorageStatisticsByTimeUnboxedDto;
}

export namespace CacheStatisticsDto {
  export const empty: CacheStatisticsDto = {
    all: StorageStatisticsSegmentDto.empty,
    byCacheId: {},
    byTime: CreatesAndDeletesByTimeDto.empty
  };

  export function combine(left: CacheStatisticsDto, right: CacheStatisticsDto): CacheStatisticsDto {
    return {
      all: StorageStatisticsSegmentDto.combine(left.all, right.all),
      byCacheId: IsoObjectUtils.fullOuterJoin(left.byCacheId, right.byCacheId, StorageStatisticsSegmentDto.combine),
      byTime: CreatesAndDeletesByTimeDto.combine(left.byTime, right.byTime)
    };
  }
}
