import {
  DailyMonthlyBytesDto,
  DailyMonthlyBytesUnboxedDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/DailyMonthlyBytesDto";

export interface StorageStatisticsByTimeDto {
  creates: DailyMonthlyBytesDto;
  deletes: DailyMonthlyBytesDto;
}

export interface StorageStatisticsByTimeUnboxedDto {
  creates: DailyMonthlyBytesUnboxedDto;
  deletes: DailyMonthlyBytesUnboxedDto;
}

export namespace CreatesAndDeletesByTimeDto {
  export const empty: StorageStatisticsByTimeDto = {
    creates: DailyMonthlyBytesDto.empty,
    deletes: DailyMonthlyBytesDto.empty
  };

  export function combine(
    left: StorageStatisticsByTimeDto,
    right: StorageStatisticsByTimeDto
  ): StorageStatisticsByTimeDto {
    return {
      creates: DailyMonthlyBytesDto.combine(left.creates, right.creates),
      deletes: DailyMonthlyBytesDto.combine(left.deletes, right.deletes)
    };
  }
}
