import {
  StorageStatisticsSegmentDto,
  StorageStatisticsSegmentUnboxedDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/StorageStatisticsSegmentDto";
import {
  UploadStatisticsDto,
  UploadStatisticsUnboxedDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/UploadStatisticsDto";
import {
  CacheStatisticsDto,
  CacheStatisticsUnboxedDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/CacheStatisticsDto";

export interface StorageStatisticsDto {
  all: StorageStatisticsSegmentDto;
  caches: CacheStatisticsDto;
  uploads: UploadStatisticsDto;
}

export interface StorageStatisticsUnboxedDto {
  all: StorageStatisticsSegmentUnboxedDto;
  caches: CacheStatisticsUnboxedDto;
  uploads: UploadStatisticsUnboxedDto;
}

export namespace StorageStatisticsDto {
  export const empty: StorageStatisticsDto = {
    all: StorageStatisticsSegmentDto.empty,
    caches: CacheStatisticsDto.empty,
    uploads: UploadStatisticsDto.empty
  };

  export function combine(left: StorageStatisticsDto, right: StorageStatisticsDto): StorageStatisticsDto {
    return {
      all: StorageStatisticsSegmentDto.combine(left.all, right.all),
      uploads: UploadStatisticsDto.combine(left.uploads, right.uploads),
      caches: CacheStatisticsDto.combine(left.caches, right.caches)
    };
  }
}
